--- /opt/local/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/site-packages/networkx/drawing/nx_pylab.py	2013-11-22 20:35:55.000000000 +0100
+++ nx_pylab.py	2013-11-22 20:29:24.000000000 +0100
@@ -396,6 +396,7 @@
                         ax=None,
                         arrows=True,
                         label=None,
+                        al=0.015,
                         **kwds):
     """Draw the edges of the graph G.
 
@@ -487,6 +488,8 @@
         edgelist=G.edges()
 
     if not edgelist or len(edgelist)==0: # no edges!
+        if G.is_directed() and arrows:
+            return None, None
         return None
 
     # set edge positions
@@ -563,13 +566,17 @@
         # waiting for someone else to implement arrows that will work
         arrow_colors = edge_colors
         a_pos=[]
-        p=1.0-0.25 # make head segment 25 percent of edge length
+
         for src,dst in edge_pos:
             x1,y1=src
             x2,y2=dst
             dx=x2-x1 # x offset
             dy=y2-y1 # y offset
             d=numpy.sqrt(float(dx**2+dy**2)) # length of edge
+            if d < al:
+              p = 0.75 # fallback if edge is too small 
+            else:
+              p = (d - al) / d # make arrow of length al
             if d==0: # source and target at same position
                 continue
             if dx==0: # vertical edge
@@ -610,7 +617,8 @@
     ax.update_datalim( corners)
     ax.autoscale_view()
 
-#    if arrow_collection:
+    if G.is_directed() and arrows:
+      return edge_collection, arrow_collection
 
     return edge_collection
 
